<template>
    <div class="table-responsive" v-if="data && state.show">
        <table class="table table-hover">
            <thead>
                <tr>
                    <th v-for="(header, index) in headers" :key="index">
                        <div
                            class="custom-control custom-checkbox"
                            v-if="header == '#'"
                        >
                            <input
                                type="checkbox"
                                class="custom-control-input"
                                id="select-list-all"
                                v-model="state.isCheckAll"
                                @click="selectAllPressed"
                            />
                            <label
                                class="custom-control-label"
                                for="select-list-all"
                            ></label>
                        </div>
                        <span v-else>{{ header }}</span>
                    </th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="(list, index) in data" :key="index">
                    <td
                        v-for="(l, li) in Object.keys(list)"
                        :key="'l-' + l"
                        :class="
                            leftAlign.includes(Object.keys(list)[li])
                                ? 'left'
                                : ''
                        "
                    >
                        <!-- Client Column -->
                        <div v-if="Object.keys(list)[li] == 'client'">
                            <template
                                v-if="
                                    list[Object.keys(list)[li]].conversation &&
                                    list[Object.keys(list)[li]].conversation
                                        .length == 0
                                "
                            >
                                {{ list[Object.keys(list)[li]].name }}
                            </template>
                            <a
                                v-else
                                href="javascript:void(0)"
                                no-caps
                                flat
                                @click="
                                    redirectPage(list[Object.keys(list)[li]].id)
                                "
                            >
                                {{ list[Object.keys(list)[li]].name }}
                            </a>
                        </div>

                        <!-- Agent Column -->
                        <div v-else-if="Object.keys(list)[li] == 'lastAgent'">
                            <span>
                                {{ list[Object.keys(list)[li]].name }}
                            </span>
                        </div>

                        <!-- Ticket ID Column -->
                        <div v-else-if="Object.keys(list)[li] == 'ticketId'">
                            <a
                                href="javascript:void(0)"
                                no-caps
                                flat
                                @click="redirectChat(list)"
                            >
                                {{ list[Object.keys(list)[li]] }}
                            </a>
                        </div>

                        <!-- Agent && Service Type -->
                        <div
                            v-else-if="Object.keys(list)[li] == 'serviceTypes'"
                        >
                            <span
                                v-for="(service, index) in list[
                                    Object.keys(list)[li]
                                ]"
                                :key="service"
                            >
                                - {{ service.name }}
                                <br
                                    v-if="
                                        index !=
                                        list[Object.keys(list)[li]].length - 1
                                    "
                                />
                            </span>
                        </div>

                        <!-- Appointment Status with action -->
                        <q-btn
                            dense
                            flat
                            size="md"
                            @click="
                                updateStatusClicked(list.status.appointmentID)
                            "
                            no-caps
                            v-else-if="
                                Object.keys(list)[li] == 'status' &&
                                currentTab == 'appointments'
                            "
                            :class="[
                                Object.keys(list)[li] == 'status'
                                    ? 'badge'
                                    : '',
                                list.status.text == 'Accepted' ? 'green' : '',
                                list.status.text == 'Rejected' ? 'red' : '',
                                list.status.text == 'Pending' ? 'yellow' : '',
                                list.status.text == 'Cancelled' ? 'red' : ''
                            ]"
                        >
                            {{ list?.status?.text }}
                        </q-btn>

                        <!-- Appointment Status without action -->
                        <span
                            dense
                            flat
                            size="md"
                            no-caps
                            v-else-if="
                                Object.keys(list)[li] == 'appointmentStatus' &&
                                currentTab == 'clients'
                            "
                            :class="[
                                Object.keys(list)[li] == 'appointmentStatus'
                                    ? 'badge'
                                    : '',
                                list.appointmentStatus.text == 'Accepted'
                                    ? 'green'
                                    : '',
                                list.appointmentStatus.text == 'Rejected'
                                    ? 'red'
                                    : '',
                                list.appointmentStatus.text == 'Pending'
                                    ? 'yellow'
                                    : '',
                                list.appointmentStatus.text == 'Cancelled'
                                    ? 'red'
                                    : ''
                            ]"
                        >
                            {{ list.appointmentStatus.text }}
                        </span>

                        <!-- Normal Text & All Chat Status-->
                        <span
                            v-else
                            :class="[
                                Object.keys(list)[li] == 'status'
                                    ? 'badge'
                                    : '',
                                list == 'Closed' ? 'green' : '',
                                list[Object.keys(list)[li]] == 'Waiting'
                                    ? 'orange'
                                    : '',
                                list[Object.keys(list)[li]] == 'Pending'
                                    ? 'yellow'
                                    : ''
                            ]"
                        >
                            {{ list[Object.keys(list)[li]] }}
                        </span>
                    </td>

                    <!-- Action -->
                    <td v-if="actions.length > 0">
                        <!-- Edit Button -->
                        <q-btn
                            v-if="actions.includes('edit')"
                            no-caps
                            class="btn btn-xs btn-light mb-1 mr-1 request"
                            @click="editBranch(list)"
                            :disable="
                                permissions.branch?.update &&
                                !business.member.isOwner
                            "
                        >
                            {{ t('button.edit', {}, { locale: lang }) }}
                        </q-btn>

                        <!-- Edit Service -->
                        <q-btn
                            v-if="actions.includes('editService')"
                            no-caps
                            class="btn btn-xs btn-light mb-1 mr-1 request"
                            @click="editService(list)"
                        >
                            {{ t('button.edit', {}, { locale: lang }) }}
                        </q-btn>

                        <!-- Edit Issue -->
                        <q-btn
                            v-if="actions.includes('editIssue')"
                            no-caps
                            class="btn btn-xs btn-light mb-1 mr-1 request"
                            @click="editIssue(list)"
                        >
                            {{ t('button.edit', {}, { locale: lang }) }}
                        </q-btn>

                        <!-- Remove Issue -->
                        <q-btn
                            v-if="remove.includes('removeIssue')"
                            no-caps
                            class="btn btn-xs btn-light mb-1 mr-1 remove"
                            @click="removeIssue(list)"
                        >
                            {{ t('button.remove', {}, { locale: lang }) }}
                        </q-btn>

                        <!-- Only possible to show All Chat , All Client Page, All Client's Page -->
                        <template v-if="conditionChatClient">
                            <!-- Transfer Button -->
                            <!-- Show while status is WAITING -->
                            <!-- Show while status is ACTIVE && is conversation owner -->
                            <!-- Show while status is ACTIVE && is business owner -->
                            <q-btn
                                v-if="transferButtonCondition(list)"
                                no-caps
                                class="btn btn-xs btn-light mb-1 mr-1 transfer"
                                @click="transferConversation(list)"
                            >
                                {{ t('button.transfer', {}, { locale: lang }) }}
                            </q-btn>

                            <!-- Request Button -->
                            <!-- Show while status is ACTIVE && is not conversation owner  && is not business owner-->
                            <q-btn
                                v-if="requestButtonCondition(list)"
                                no-caps
                                class="btn btn-xs btn-light mb-1 mr-1 request"
                                @click="requestConversation(list)"
                            >
                                {{ t('button.request', {}, { locale: lang }) }}
                            </q-btn>

                            <!--  Message Button -->
                            <!-- Show while status is ACTIVE && is conversation owner -->
                            <!-- Show while status is CLOSED -->
                            <actions-button
                                v-if="messageButtonCondition(list)"
                                :conversation="
                                    formatConversationMessageButton(list)
                                "
                                :clientId="list.client?.id ?? ''"
                            />
                        </template>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>

    <div v-else>
        <p>{{ t('tables.empty', {}, { locale: lang }) }}</p>
    </div>
</template>

<script lang="ts">
import { defineComponent, reactive, computed, onMounted } from 'vue';
import { VueCookieNext } from 'vue-cookie-next';
import { useI18n } from 'vue-i18n';
import { useRouter } from 'vue-router';
import { useStore } from 'src/store';
import { mapGetters } from 'vuex';
import ActionsButton from 'src/components/chats/ActionsButton.vue';
import { ConversationStatus } from 'src/services/enums/ConversationStatus';

export default defineComponent({
    name: 'VueDataTable',
    components: {
        ActionsButton
    },
    computed: {
        ...mapGetters({
            business: 'business/getBusiness',
            permissions: 'role/getPermissions'
        })
    },
    props: {
        headers: {
            type: Object as () => any,
            required: true
        },
        data: {
            type: Object as () => any,
            required: true
        },
        actions: {
            type: Object as () => any,
            default: [] as any
        },
        remove: {
            type: Object as () => any,
            default: [] as any
        },
        leftAlign: {
            type: Object as () => any,
            default: [] as any
        },
        viewClientButtonPressed: {
            type: Function,
            default: () => ''
        },
        requestConversationButtonPressed: {
            type: Function,
            default: () => ''
        },
        editBranchButtonPressed: {
            type: Function,
            default: () => ''
        },
        editServiceType: {
            type: Function,
            default: () => ''
        },
        editIssueType: {
            type: Function,
            default: () => ''
        },
        removeIssueType: {
            type: Function,
            default: () => ''
        },
        transferConversationButtonPressed: {
            type: Function,
            default: () => ''
        },
        ticketIDLinkPressed: {
            type: Function,
            default: () => ''
        },
        updateStatus: {
            type: Function,
            default: () => ''
        },
        conditionChatClient: {
            type: Boolean,
            default: false
        }
    },
    setup(props) {
        // data

        let state = reactive({
            isCheckAll: false,
            selected: [null],
            show: false
        });

        const router = useRouter();
        const store = useStore();
        // localization
        const { t, locale } = useI18n();

        const lang = VueCookieNext.isCookieAvailable('l')
            ? VueCookieNext.getCookie('l')
            : 'en';

        const currentTab = computed(() => {
            return store.state.menu.selectedShortcut;
        });

        const route = router.currentRoute.value.path;

        // methods
        const selectAllPressed = () => {
            state.isCheckAll = !state.isCheckAll;
            state.selected = [];
        };

        const redirectPage = (id: any) => {
            router.push('/user/' + id);
            store.dispatch('menu/setSelectedShortcut', 'clients');
        };

        const redirectChat = (ticketID: any) => {
            props.ticketIDLinkPressed(ticketID);
        };

        const viewClient = (client: any) => {
            props.viewClientButtonPressed(client);
        };

        const requestConversation = (conversation: any) => {
            props.requestConversationButtonPressed(conversation.ticketId);
        };

        const transferConversation = (conversation: any) => {
            /* ticketIdState(conversation.ticketId) */
            props.transferConversationButtonPressed(conversation.ticketId);
        };

        const editBranch = (branch: any) => {
            /* ticketIdState(conversation.ticketId) */
            props.editBranchButtonPressed(branch);
        };

        const editService = (service: any) => {
            props.editServiceType(service);
        };

        const editIssue = (issue: any) => {
            props.editIssueType(issue);
        };

        const removeIssue = (issue: any) => {
            props.removeIssueType(issue);
        };

        const updateStatusClicked = (appointmentID: any) => {
            props.updateStatus(appointmentID);
        };

        const show = () => {
            setTimeout(() => {
                state.show = true;
            }, 500);
        };

        // Conditioning for All Client and All Chat

        // Transfer Button Condition
        const transferButtonCondition = (list: any) => {
            return (
                checkStatus(list) &&
                (checkIsWaiting(list) ||
                    (checkIsActive(list) &&
                        (belongToAgent(list) || businessOwner())))
            );
        };

        // Request Button Condition
        const requestButtonCondition = (list: any) => {
            return (
                checkStatus(list) &&
                notBelongToCurrentAgent(list) &&
                checkIsActive(list) &&
                !businessOwner() &&
                !transferButtonCondition(list)
            );
        };

        // Message Button Condition
        const messageButtonCondition = (list: any) => {
            return (
                checkIsClosed(list) ||
                (checkIsActive(list) && belongToAgent(list))
            );
        };

        // Sub Condition
        const checkIsWaiting = (list: any) => {
            if (list.status == undefined) {
                return (
                    list.client.conversation.status ==
                    ConversationStatus.WAITING
                );
            }
            return list.status == 'Waiting';
        };

        const checkIsActive = (list: any) => {
            if (list.status == undefined) {
                return (
                    list.client.conversation.status == ConversationStatus.ACTIVE
                );
            }
            return list.status == 'Active';
        };

        const checkIsClosed = (list: any) => {
            if (list.status == undefined) {
                if (list.client.conversation.length == 0) {
                    list.client.conversation.status = ConversationStatus.NEW;
                }
                return (
                    list.client.conversation.status ==
                        ConversationStatus.CLOSED ||
                    list.client.conversation.status == ConversationStatus.NEW
                );
            }
            return list.status == 'Closed';
        };

        const checkStatus = (list: any) => {
            if (list.status == undefined) {
                if (list.client.conversation.length == 0) {
                    return true;
                }
                return false;
            } else {
                return true;
            }
        };

        const notBelongToCurrentAgent = (list: any) => {
            if (list.lastAgent) {
                return (
                    list.lastAgent.id != store.state.user.user?.id &&
                    list.lastAgent.id != null
                );
            }
        };

        const belongToAgent = (list: any) => {
            if (list.lastAgent && list.lastAgent.id) {
                return list.lastAgent.id == store.state.user.user?.id;
            } else if (
                list.client &&
                list.client.conversation &&
                list.client.conversation.agent
            ) {
                return (
                    list.client.conversation.agent.id ==
                    store.state.user.user?.id
                );
            } else {
                return false;
            }
        };

        const businessOwner = () => {
            return store.getters['business/getBusiness'].member.isOwner;
        };

        const formatConversationMessageButton = (list: any) => {
            if (list.client) {
                return list.client.conversation;
            }
        };

        onMounted(show);

        // return data
        return {
            t,
            locale,
            lang,
            state,
            selectAllPressed,
            viewClient,
            redirectPage,
            requestConversation,
            transferConversation,
            editBranch,
            notBelongToCurrentAgent,
            belongToAgent,
            redirectChat,
            checkIsWaiting,
            editService,
            editIssue,
            removeIssue,
            currentTab,
            updateStatusClicked,
            route,
            transferButtonCondition,
            requestButtonCondition,
            messageButtonCondition,
            formatConversationMessageButton
        };
    }
});
</script>
